﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Query;
using System.Xml.XLinq;
using System.Data.DLinq;
using BuildingBlocks.Time;

namespace FluentInterfaces
{
    #region Time
    public static class TimeExtenders
    {
        public static DateTime Ago(this TimeSpan val)
        {
            return DateTime.Now.Subtract(val);
        }

        public static TimeSpan Minutes(this int val)
        {
            return new TimeSpan(0, val, 0);
        }
    }
    #endregion
    
    class Program
    {
        static void Main(string[] args)
        {
            #region TimeAndMoney
            //CalendarDate dueDate = CalendarDate.From(2007, 06, 07).Month().End().PlusDays(10);
            //Console.WriteLine(string.Format("Due Date: {0}", dueDate.ToString()));

            //int tooLong = CalendarDate.From(2006, 12, 2).Through(CalendarDate.From(2007, 06, 30)).LengthInMonths().CompareTo(Duration.Months(6));
            //Console.WriteLine(tooLong == 0 ? "Spot On" : "What went wrong");

            #endregion

            #region RubyTime
            //Ruby: 
            //time = 20.minutes.ago
            //puts time
            
            //.NET
            DateTime netTime = DateTime.Now.Subtract(new TimeSpan(0, 20, 0));
            Console.WriteLine(netTime);

            //TimeAndMoney: 
            TimePoint eeTime = TimePoint.From(DateTime.Now).Minus(Duration.Minutes(20));
            Console.WriteLine(eeTime);
            
            //Extensions
            DateTime extTime = 20.Minutes().Ago();
            Console.WriteLine(extTime);

            #endregion
        }
    }
}
